package com.compo.camera.algorithms;

import android.graphics.Bitmap;
import android.graphics.Color;
import android.support.v7.graphics.Palette;
import android.util.Log;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by lmodlinski on 25/03/17.
 */
public class ColorAssessment
{
	public ColorAssessment()
	{

	}

	public static boolean assess(Bitmap bitmap, double threshold, int match, int palette, double population)
	{
		List<Palette.Swatch> swatchesTemp = Palette.from(bitmap)
				.maximumColorCount(palette).generate().getSwatches();
		List<Palette.Swatch> swatches = new ArrayList<Palette.Swatch>(swatchesTemp);

		int total_population = 0;

		for (Palette.Swatch swatch : swatches) {
			total_population += swatch.getPopulation();
		}

		Log.e("Color", "Next...");

		for (Palette.Swatch swatch : swatches) {
			double swatch_population = ((double) swatch.getPopulation() / (double) total_population);

			if (population < swatch_population) {
				double distance = distance(match, swatch.getRgb());

				Log.e("Color", "LF: " + Integer.toHexString(swatch.getRgb())
						+ " | M: " + Integer.toHexString(match)
						+ " | D: " + distance
						+ " | T: " + threshold);

				if (threshold > distance) {
					return true;
				}
			} else {
				Log.e("Color", "Population low: " + swatch_population);
			}
		}

		return false;
	}

	public static double distance(int color_1, int color_2)
	{
		int c1_r = Color.red(color_1);
		int c1_g = Color.green(color_1);
		int c1_b = Color.blue(color_1);

		int c2_r = Color.red(color_2);
		int c2_g = Color.green(color_2);
		int c2_b = Color.blue(color_2);

		return Math.abs(c1_r - c2_r) + Math.abs(c1_g - c2_g) + Math.abs(c1_b - c2_b);

//		return Math.sqrt((c1_r - c2_r) * (c1_r - c2_r) * 2.0
//						+ (c1_g - c2_g) * (c1_g - c2_g) * 4.0
//						+ (c1_b - c2_b) * (c1_b - c2_b) * 3.0
//		);

//		return Math.sqrt((c1_r - c2_r) * (c1_r - c2_r) * 2.0
//						+ (c1_g - c2_g) * (c1_g - c2_g) * 4.0
//						+ (c1_b - c2_b) * (c1_b - c2_b) * 3.0
//		);
	}
}